package classexplorer.panel;

/*
 * Panel pour afficher les informations de la classe
 */

import javax.swing.*;
import java.awt.*;
import classexplorer.reflect.ClassInformations;

public class ClassInformationsPanel extends JPanel {

    /* Attributs privés */
    private ClassInformations classInfos;

    /* Constructeur */
    public ClassInformationsPanel() {
        this.setBackground(Color.WHITE);
    }

    /* Cherche des informations (package, classe mère, interfaces implémentées) sur la classe */
    public void findInformations(Class c) throws ClassNotFoundException {
        classInfos = new ClassInformations(c);
        String pack = classInfos.getPackage();
        String declarationString = classInfos.getDeclarationString();

        JLabel lblPackage = new JLabel(pack);
        JLabel lblDeclarationString = new JLabel(declarationString);
        lblPackage.setFont(new Font("Lucida Console", Font.BOLD, 12));
        lblDeclarationString.setFont(new Font("Lucida Console", Font.BOLD, 12));

        JPanel pan = new JPanel();
        pan.setBackground(Color.WHITE);
        BoxLayout box = new BoxLayout(pan, BoxLayout.Y_AXIS);
        pan.setLayout(box);
        pan.add(new JLabel("Package :"));
        pan.add(new JLabel(System.getProperty("line.separator")));
        pan.add(lblPackage);
        pan.add(new JLabel(System.getProperty("line.separator")));
        pan.add(new JLabel(System.getProperty("line.separator")));
        pan.add(new JLabel("Déclaration :"));
        pan.add(new JLabel(System.getProperty("line.separator")));
        pan.add(lblDeclarationString);

        this.setLayout(new FlowLayout());
        this.add(pan, BorderLayout.CENTER);
        this.revalidate();
    }
}