package classexplorer.panel;

/*
 * Panel pour afficher les méthodes de la classe
 */

import javax.swing.*;
import java.awt.*;
import java.util.ArrayList;
import classexplorer.reflect.ClassMethods;

public class ClassMethodsPanel extends JPanel {

    /* Attributs privés */
    private ClassMethods classMethods;

    /* Constructeur */
    public ClassMethodsPanel() {
        this.setBackground(Color.WHITE);
    }

    /* Cherche les méthodes de la classe */
    public void findInformations(Class c) throws ClassNotFoundException{
        classMethods = new ClassMethods(c);
        ArrayList<String> constructorList = classMethods.getMethodList();
        DefaultListModel listModel = new DefaultListModel();
        JList list = new JList(listModel);
        for (String str : constructorList) {
            listModel.addElement(str);
        }
        this.setLayout(new BorderLayout());
        this.add(new JScrollPane(list), BorderLayout.CENTER);
        this.revalidate();
    }
}