package classexplorer.reflect;

/*
 * Fournit la liste des attributs de la classe
 */

import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import java.util.ArrayList;

public class ClassFields {

    /* Attributs privés */
    private Class c;

    /* Constructeur de la classe */
    public ClassFields(Class c) {
        this.c = c;
    }

    /* Méthode qui retourne un liste des attributs de la classe recherchée */
    public ArrayList<String> getFieldsList() {
        Field fields[] = c.getFields();
        ArrayList<String> fieldList = new ArrayList<String>();

        for (Field field : fields) {
            StringBuilder str = new StringBuilder();
            str.append(Modifier.toString(field.getModifiers()) + " " + field.getName());
            // On ajoute une entrée dans l'ArrayList
            fieldList.add(str.toString());
        }

        return fieldList;
    }
}