package classexplorer.util;

/*
 * Chargeurs de jars
 */

import java.util.jar.JarFile;
import java.util.jar.JarEntry;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Enumeration;
import java.net.URLClassLoader;
import java.net.URL;
import java.net.MalformedURLException;

public class JarLoader {

    /* Attributs privés */
    private String jarName;

    /* Constructeur */
    public JarLoader(String name) {
        this.jarName = name;
    }

    /* Retourne la liste des classes contenues dans le jar */
    public ArrayList<String> getClassList() throws IOException {
        ArrayList<String> classList = new ArrayList<String>();
        JarFile jarFile = null;
        try {
            jarFile = new JarFile(jarName);
            Enumeration<JarEntry> entries = jarFile.entries();
            while (entries.hasMoreElements()) {
                String entry = entries.nextElement().getName();
                if (entry.endsWith(".class")) {
                    entry = entry.replace("/", ".").substring(0, entry.length()-6);
                    classList.add(entry);
                }
            }
        }
        finally {
            jarFile.close();
        }

        return classList;            
    }

    /* Charge une classe donnée */
    public Class loadClass(String className) throws MalformedURLException, ClassNotFoundException, IOException {
        new java.io.File(jarName);
        URL url[] = new URL[] {new URL("file:" + jarName)};
        URLClassLoader classLoader = new URLClassLoader(url);
        return classLoader.loadClass(className);        
    }
}